diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_build.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_build.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_build.cpp	2010-05-18 19:32:31.876848937 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_build.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -29,7 +29,7 @@
 
 #if defined(__MSVCDOTNET__) || defined(__TOOLS2__)
 	#include <iomanip>
-	#include <strstream>
+	#include <sstream>
 #else //!__MSVCDOTNET__
 	#include <iomanip.h>
 #endif //__MSVCDOTNET__
@@ -1218,22 +1218,11 @@
 				f.UpdateHeaderCrc();
 				if (overflow)
 					{
-					char * buffer = new char [size];
-					// need to check if the compressed file will fit in the image
-   					#if defined(__LINUX__)
- 					ostrstream os((char*)aDest, aMaxSize, (ios::openmode)(ios::out+ios::binary));
-					#elif defined(__TOOLS2__) && defined (_STLP_THREADS)
-  					ostrstream os((char*)buffer, size,(ios::out+ios::binary));
-  					#elif defined( __TOOLS2__)
-   					ostrstream os((char*)buffer, size,(ios::out+ios::binary));
-					#else
-					ostrstream os( (char*)buffer, size, (ios::out+ios::binary));
-					#endif
+					ostringstream os(ios_base::out|ios_base::binary);
 					os << f;
-					TUint compressedSize = os.pcount();
+					TUint compressedSize = os.str().size();
 					if (compressedSize <= aMaxSize)
 						overflow = EFalse;	
-					delete[] buffer;
 					}
 				}
 			if (overflow)
@@ -1242,15 +1231,9 @@
 				Print(EError, "Overflowed by approximately 0x%x bytes.\n", size - aMaxSize);
 				exit(667);
 				}
-  			#if defined(__TOOLS2__) && defined (_STLP_THREADS)
-  			ostrstream os((char*)aDest, aMaxSize,(ios::out+ios::binary));
-  			#elif __TOOLS2__
-			ostrstream os((char*)aDest, aMaxSize, (std::_Ios_Openmode)(ios::out+ios::binary));
-			#else
-			ostrstream os((char*)aDest, aMaxSize, (ios::out+ios::binary));
-			#endif
+  			ostringstream os(ios_base::out|ios_base::binary);
 			os << f;
-			size = os.pcount();
+			size = os.str().size();
 			compression = f.iHdr->CompressionType();
 			memcpy(&iUids[0], aDest, sizeof(iUids));
 			}
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_coreimage.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_coreimage.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_coreimage.cpp	2010-05-18 19:32:31.876848937 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_coreimage.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -305,7 +305,7 @@
 @param aInfo Used by the caller to identify where the error occurred.
 @return Error number. KErrNone is returned if there are no errors.
 */
-TInt RCoreImageReader::ImageError(int aItemsRead, int aExpected, char *aInfo)
+TInt RCoreImageReader::ImageError(int aItemsRead, int aExpected, char const *aInfo)
 	{
 	if (aItemsRead != aExpected)
 		{
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_coreimage.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_coreimage.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_coreimage.h	2010-05-18 19:32:31.876848937 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_coreimage.h	2010-05-15 14:32:45.000000000 +0100
@@ -103,7 +103,7 @@
 	TText* Filename();
 private:
 	TInt ReadIdentifier();
-	TInt ImageError(int aBytesRead, int aExpected, char* aInfo);
+	TInt ImageError(int aBytesRead, int aExpected, char const* aInfo);
 
 	/** Image type of the file being read */
 	TImageType iImageType;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_driveimage.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_driveimage.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_driveimage.cpp	2010-05-18 19:32:31.876848937 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_driveimage.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -254,7 +254,7 @@
 	fileName.append("/");
 
 	// Go through each entry
-	while(dirEntry = readdir(dirHandler))
+	while((dirEntry = readdir(dirHandler)) != NULL)
 		{
 		if(dirEntry->d_type != DT_DIR) 
 			{
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_driveutl.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_driveutl.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_driveutl.cpp	2010-05-18 19:32:31.876848937 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_driveutl.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -82,7 +82,7 @@
 /**
 Time Stamp for Log file.
 */ 
-TAny GetLocalTime(TAny)
+TAny GetLocalTime()
 	{
 	struct tm *aNewTime = NULL;
 	time_t aTime = 0;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_driveutl.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_driveutl.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_driveutl.h	2010-05-18 19:32:31.880850004 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_driveutl.h	2010-05-15 14:32:45.000000000 +0100
@@ -24,6 +24,6 @@
 #include <e32def.h>
 
 TInt Getlogfile(TText *aDriveObeyFileName,TText* &aPadLogFile);
-TAny GetLocalTime(TAny);
+TAny GetLocalTime();
 
 #endif
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_obey.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_obey.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_obey.cpp	2010-05-18 19:32:31.880850004 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_obey.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -47,6 +47,7 @@
 #include <time.h>
 #include <assert.h>
 #include <errno.h>
+#include <limits.h>
 
 #include <e32std.h>
 #include <e32std_private.h>
@@ -283,7 +284,7 @@
 	iCurrentLine++;
 	iCurrentMark = ftell(iObeyFile);
 	iLine[0]='\0';
-	fgets((char*)iLine,imaxLength+1,iObeyFile);
+	char *cp = fgets((char*)iLine,imaxLength+1,iObeyFile); (void)cp;
 	iCurrentObeyStatement = new TText[imaxLength+1];
 	strcpy((char*)iCurrentObeyStatement,(char*)iLine);
 	iNumWords = Parse();
@@ -646,13 +647,7 @@
 		{
 		  if (keyword == EKeywordCoreImage)
 			  {
-  			  #if defined(__TOOLS2__) && defined (_STLP_THREADS)
-  			  istringstream val(iReader.Word(1),(ios_base::in+ios_base::out));	  
-  			  #elif __TOOLS2__
-  			  istringstream val(iReader.Word(1),(std::_Ios_Openmode)(ios_base::in+ios_base::out));
-			  #else
-			  istrstream val(iReader.Word(1),strlen(iReader.Word(1)));
-			  #endif
+			istringstream val(iReader.Word(1),ios_base::in|ios_base::out);	  
 			  iReader.CopyWord(1, coreImageFileName);
 			  iReader.MarkNext(); // ready for processing extension
 			  break;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/rofsbuild.mmp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/rofsbuild.mmp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/rofsbuild.mmp	2010-05-18 19:32:31.880850004 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/rofsbuild.mmp	2010-05-15 14:32:45.000000000 +0100
@@ -43,15 +43,16 @@
 USERINCLUDE   ../../imglib/inc ../../imglib/compress ../../imglib/filesystem/include 
 USERINCLUDE   ../../imglib/patchdataprocessor/include ../../imglib/parameterfileprocessor/include
 USERINCLUDE	  ../../imglib/memmap/include
+#ifndef TOOLS2_LINUX
 USERINCLUDE   ../../imglib/boostlibrary/
+#endif
 
 STATICLIBRARY 	filesystem 
 STATICLIBRARY   patchdataprocessor
 STATICLIBRARY   parameterfileprocessor
 STATICLIBRARY	memmap
 #ifdef TOOLS2_LINUX
-STATICLIBRARY   boost_thread-mgw34-mt-1_39_linux
-OPTION    GCC -pthread -O2 -Wno-uninitialized
+OPTION    GCC -pthread -O2 -Wno-uninitialized -lboost_thread-mt
 #else
 STATICLIBRARY   boost_thread-mgw34-mt-1_39_win32
 OPTION    GCC -mthreads -O2 -Wno-uninitialized
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_rofs.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_rofs.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rofsbuild/r_rofs.cpp	2010-05-18 19:32:31.880850004 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rofsbuild/r_rofs.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -584,9 +584,10 @@
 			coffhead[0x54] = 0x20;
 
 			// now fill in the text segment size
-			*(TUint32 *) (&coffhead[0x18]) = ALIGN4K(iSizeUsed);
-			*(TUint32 *) (&coffhead[0x40]) = ALIGN4K(iSizeUsed);
-
+			TUint32 * p0x18 = reinterpret_cast<TUint32 *>(&coffhead[0x18]);
+			*p0x18 = ALIGN4K(iSizeUsed);
+			TUint32 * p0x40 = reinterpret_cast<TUint32 *>(&coffhead[0x40]);
+			*p0x40 = ALIGN4K(iSizeUsed);
 			os.write(reinterpret_cast<char *>(coffhead), sizeof(coffhead));
 			}
 		break;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/r_areaset.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/r_areaset.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/r_areaset.cpp	2010-05-18 19:32:31.884849046 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/r_areaset.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -47,7 +47,7 @@
 Area::~Area()
 	{
 	ReleaseAllFiles();
-	free(const_cast<char*>(iName));	// allocated with strdup()
+	free(iName);	// allocated with strdup()
 	}
 
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/r_areaset.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/r_areaset.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/r_areaset.h	2010-05-18 19:32:31.884849046 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/r_areaset.h	2010-05-15 14:32:45.000000000 +0100
@@ -104,7 +104,7 @@
 public:
 	TRomBuilderEntry* iFirstPagedCode; // For PagedRom only
 private:
-	const char* iName;
+	char* iName;
 	TLinAddr iDestBaseAddr;
 	TLinAddr iSrcBaseAddr;
 	TLinAddr iSrcLimitAddr;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/r_obey.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/r_obey.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/r_obey.cpp	2010-05-18 19:32:31.888848507 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/r_obey.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -301,7 +301,7 @@
 	iCurrentLine++;
 	iCurrentMark = ftell(iObeyFile);
 	iLine[0]='\0';
-	fgets((char*)iLine,imaxLength+1,iObeyFile);
+	char * cp = fgets((char*)iLine,imaxLength+1,iObeyFile); (void)cp;
 	iNumWords = Parse();
 	return KErrNone;
 	}
@@ -2973,13 +2973,7 @@
 	{
 		if (keyword == EKeywordCoreImage)
 		{
-#if defined(__TOOLS2__) && defined (_STLP_THREADS)
-			istringstream val(iReader.Word(1),(ios_base::in+ios_base::out));	  
-#elif __TOOLS2__
-			istringstream val(iReader.Word(1),(std::_Ios_Openmode)(ios_base::in+ios_base::out));
-#else
-			istrstream val(iReader.Word(1),strlen(iReader.Word(1)));
-#endif
+			istringstream val(iReader.Word(1),ios_base::in|ios_base::out);
 			iReader.CopyWord(1, coreImageFileName);
 			break;
 		}
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/rombuild.mmp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/rombuild.mmp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/rombuild.mmp	2010-05-18 19:32:31.892848597 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/rombuild.mmp	2010-05-15 14:32:45.000000000 +0100
@@ -41,7 +41,9 @@
 userinclude	../../imglib/compress 	../../imglib/inc 
 userinclude	../../imglib/patchdataprocessor/include ../../imglib/parameterfileprocessor/include
 userinclude ../../imglib/memmap/include
+#ifndef TOOLS2_LINUX
 userinclude	../../imglib/boostlibrary/
+#endif
 
 OS_LAYER_SYSTEMINCLUDE_SYMBIAN
 
@@ -50,8 +52,7 @@
 staticlibrary 	memmap
 
 #ifdef TOOLS2_LINUX
-STATICLIBRARY   boost_thread-mgw34-mt-1_39_linux
-OPTION    GCC -O2 -Wno-uninitialized -pthread
+OPTION    GCC -pthread -O2 -Wno-uninitialized -lboost_thread-mt
 #else
 STATICLIBRARY   boost_thread-mgw34-mt-1_39_win32
 OPTION    GCC -O2 -Wno-uninitialized -mthreads
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/r_rom.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/r_rom.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/romtools/rombuild/r_rom.cpp	2010-05-18 19:32:31.892848597 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/romtools/rombuild/r_rom.cpp	2010-05-15 14:32:45.000000000 +0100
@@ -1835,7 +1835,7 @@
 			TRomFile** l=rf->iPDeps;
 			FindMarked(MARK_EXE, MARK_EXE, l);
 			TInt nx=l-rf->iPDeps;
-			if (!e->IsDll() && (nx>1 || nx==1 && l[-1]!=rf))
+			if (!e->IsDll() && (nx>1 || (nx==1 && l[-1]!=rf)))
 				{
 				Print(EError,"EXE %s links to the following other EXEs:\n", e->iFileName);
 				TInt j;
@@ -2198,8 +2198,11 @@
 			coffhead[0x54] = 0x20;
 
 			// now fill in the text segment size
-			*(TUint32 *) (&coffhead[0x18]) = ALIGN4K(iSizeUsed);
-			*(TUint32 *) (&coffhead[0x40]) = ALIGN4K(iSizeUsed);
+			TUint32 * p0x18 = reinterpret_cast<TUint32 *>(&coffhead[0x18]);
+			*p0x18 = ALIGN4K(iSizeUsed);
+			TUint32 * p0x40 = reinterpret_cast<TUint32 *>(&coffhead[0x40]);
+			*p0x40 = ALIGN4K(iSizeUsed);
+
 
 			os.write(reinterpret_cast<char *>(coffhead), sizeof(coffhead));
 			}
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/inc/pkgfileparser.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/inc/pkgfileparser.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/inc/pkgfileparser.h	2010-05-18 19:32:31.896848966 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/inc/pkgfileparser.h	2010-05-15 14:32:45.000000000 +0100
@@ -33,6 +33,10 @@
 
 #include "pkglanguage.h"
 
+int CompareTwoString(wchar_t const * string ,wchar_t const * option);
+int CompareNString(wchar_t const * string ,wchar_t const * option, int len);
+
+
 typedef class PkgParser PKGPARSER, *PPKGPARSER;
 
 //Data structures for pkg file parsing
@@ -147,7 +151,7 @@
 	int OpenFile();
 	void DeleteAll();
 
-	HANDLE iPkgHandle;
+	FILE * iPkgHandle;
 
 	LANGUAGE_LIST iLangList;
 	PKG_HEADER iPkgHeader;
@@ -162,7 +166,7 @@
 	void GetNextChar();
 	void GetNextToken();
 	bool GetStringToken();
-	WORD ParseEscapeChars();
+	unsigned short ParseEscapeChars();
 	void GetAlphaNumericToken();
 	bool IsNumericToken();
 	void GetNumericToken();
@@ -193,12 +197,12 @@
 	VARIANTVAL m_tokenValue;
 	int m_nLineNo;
 
-	void ParserError(char* msg);
+	void ParserError(char const* msg);
 
 	friend String wstring2string (const std::wstring& aWide);
 	friend std::wstring string2wstring (const String& aNarrow);
-	friend int CompareTwoString(wchar_t* string ,wchar_t* option);
-	friend int CompareNString(wchar_t* string ,wchar_t* option, int len);
+    friend int CompareTwoString(wchar_t const * string ,wchar_t const * option);
+    friend int CompareNString(wchar_t const * string ,wchar_t const * option, int len);
 };
 
 #endif //__PKGFILEPARSER_H__
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/inc/pkglanguage.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/inc/pkglanguage.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/inc/pkglanguage.h	2010-05-18 19:32:31.896848966 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/inc/pkglanguage.h	2010-05-15 14:32:45.000000000 +0100
@@ -26,7 +26,7 @@
 
 typedef struct
 {
-	wchar_t*		iName;
+	wchar_t const *		iName;
 	unsigned long	iId;
 } SKeyword;
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/inc/sis2iby.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/inc/sis2iby.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/inc/sis2iby.h	2010-05-18 19:32:31.896848966 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/inc/sis2iby.h	2010-05-15 14:32:45.000000000 +0100
@@ -38,7 +38,7 @@
 class Sis2Iby : public SisUtils
 {
 public:
-	Sis2Iby(char* aFile);
+	Sis2Iby(char const* aFile);
 	~Sis2Iby();
 
 	void ProcessSisFile();
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/inc/sisutils.h /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/inc/sisutils.h
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/inc/sisutils.h	2010-05-18 19:32:31.896848966 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/inc/sisutils.h	2010-05-15 14:32:45.000000000 +0100
@@ -40,6 +40,9 @@
 #ifdef WIN32
 #define PATHSEPARATOR  "\\"
 #endif
+#ifdef __LINUX__
+#define PATHSEPARATOR  "/"
+#endif
 
 //typedefs
 typedef std::string String;
@@ -53,7 +56,7 @@
 class SisUtils
 {
 public:
-	SisUtils(char* aFile);
+	SisUtils(char const* aFile);
 	virtual ~SisUtils();
 
 	void SetVerboseMode();
@@ -81,7 +84,7 @@
 class SisUtilsException
 {
 public:
-	SisUtilsException(char* aFile, char* aErrMessage);
+	SisUtilsException(char const* aFile, char const* aErrMessage);
 	virtual ~SisUtilsException();
 	virtual void Report();
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/src/pkgfileparser.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/src/pkgfileparser.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/src/pkgfileparser.cpp	2010-05-18 19:32:31.896848966 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/src/pkgfileparser.cpp	2010-05-15 17:10:43.000000000 +0100
@@ -18,13 +18,16 @@
 
 #include "sisutils.h"
 #include "pkgfileparser.h"
+#include <vector>
+#include <wchar.h>
+#include <cstdlib>
 
 // Parse options lookups
 #define MAXTOKENLEN	30
 struct SParseToken
 {
-	WCHAR pszOpt[MAXTOKENLEN];
-	DWORD dwOpt;
+	wchar_t pszOpt[MAXTOKENLEN];
+	unsigned dwOpt;
 };
 
 const SParseToken KTokens[] =
@@ -46,6 +49,10 @@
 };
 #define NUMPARSETOKENS (sizeof(KTokens)/sizeof(SParseToken))
 
+std::wstring string2wstring (const String& aNarrow);
+String wstring2string (const std::wstring& aWide);
+
+
 /**
 Constructor: PkgParser class
 Initilize the parameters to data members.
@@ -68,9 +75,9 @@
 */
 PkgParser::~PkgParser()
 {
-	if(iPkgHandle != INVALID_HANDLE_VALUE)
+	if(iPkgHandle)
 	{
-		::CloseHandle(iPkgHandle);
+		std::fclose(iPkgHandle);
 	}
 
 	DeleteAll();
@@ -84,9 +91,14 @@
 */
 int PkgParser::OpenFile()
 {
-	iPkgHandle = ::CreateFileW(string2wstring(iPkgFile).data(),GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
+#ifdef WIN32
+	iPkgHandle = _wfopen(string2wstring(iPkgFile).c_str(),L"r");
+#else
+	// *nix fopen doesn't care about the filename encoding, as long as its NULL-terminated.
+	iPkgHandle = std::fopen(iPkgFile.c_str(),"r");
+#endif
+	return iPkgHandle ? 1 : 0;
 	
-	return (iPkgHandle != INVALID_HANDLE_VALUE) ? 1 : 0;
 }
 
 /**
@@ -164,7 +176,7 @@
 {
 	if(!OpenFile())
 	{
-		throw SisUtilsException((char*)iPkgFile.data(), "Could not open file");
+		throw SisUtilsException(iPkgFile.c_str(),"Could not open file");
 	}
 
 	GetNextChar();
@@ -273,7 +285,7 @@
 	
 	// process application names
 	ExpectToken('{');
-	for (WORD wNumLangs = 0; wNumLangs < iLangList.size(); wNumLangs++)
+	for (unsigned short wNumLangs = 0; wNumLangs < iLangList.size(); wNumLangs++)
 	{
 		GetNextToken ();
 		ExpectToken(QUOTED_STRING_TOKEN);
@@ -771,7 +783,7 @@
 */
 void PkgParser::ParseOptionsBlockL()
 {
-	WORD wNumLangs;
+	unsigned short wNumLangs;
 	
 	ExpectToken('(');
 	GetNextToken ();
@@ -838,7 +850,7 @@
 void PkgParser::ParseVendorNameL()
 {
 	ExpectToken('{');
-	for (WORD wNumLangs = 0; wNumLangs < iLangList.size(); wNumLangs++)
+	for (unsigned short wNumLangs = 0; wNumLangs < iLangList.size(); wNumLangs++)
 	{
 		GetNextToken ();
 		ExpectToken(QUOTED_STRING_TOKEN);
@@ -990,14 +1002,8 @@
 */
 void PkgParser::GetNextChar()
 {
-#ifdef WIN32
-	DWORD dwBytesRead;
-	if (!::ReadFile(iPkgHandle, (LPVOID)&m_pkgChar, sizeof(WCHAR), &dwBytesRead, NULL) ||
-		dwBytesRead!=sizeof(wchar_t))
-		m_pkgChar='\0';
-#else
-#error "TODO: Implement this function under other OS than Windows"
-#endif
+	wint_t wch = std::fgetwc(iPkgHandle);
+	m_pkgChar = (wch == WEOF) ? 0 : wch;
 }
 
 /**
@@ -1105,10 +1111,10 @@
 */
 bool PkgParser::GetStringToken()
 {
-	DWORD wCount = 0;
+	unsigned wCount = 0;
 	bool done=false;
 	bool finished=false;
-	DWORD escapeChars = 0;
+	unsigned escapeChars = 0;
 	
 	while (!finished)
 	{
@@ -1153,15 +1159,16 @@
 @internalComponent
 @released
 */
-WORD PkgParser::ParseEscapeChars()
+unsigned short PkgParser::ParseEscapeChars()
 {
-	WORD found=0;
-	WCHAR temp[MAX_STRING];
-#ifdef WIN32
+	unsigned short found=0;
+	wchar_t temp[MAX_STRING];
+
 	while (m_pkgChar == '<')
 	{
 		wcscpy(temp,m_tokenValue.pszString);
-		DWORD fileOffset=::SetFilePointer(iPkgHandle, 0L, NULL, FILE_CURRENT);
+		std::fpos_t foff;
+		std::fgetpos(iPkgHandle,&foff);
 		try
 		{
 			GetNextChar();
@@ -1170,32 +1177,29 @@
 				found++;
 			else
 			{
-				::SetFilePointer(iPkgHandle, fileOffset, NULL, FILE_BEGIN);
+				std::fsetpos(iPkgHandle,&foff);
 				break;
 			}
 		}
 		catch (...)
 		{
 			wcscpy(m_tokenValue.pszString,temp);
-			::SetFilePointer(iPkgHandle, fileOffset, NULL, FILE_BEGIN);
+			std::fsetpos(iPkgHandle,&foff);
 			break;
 		}
-		DWORD num=m_tokenValue.dwNumber;
+		unsigned num=m_tokenValue.dwNumber;
 		// watch for CP1252 escapes which aren't appropriate for UNICODE
 		if (num>=0x80 && num<=0x9F) ParserError("Invalid Escape");
-		DWORD len=wcslen(temp);
+		unsigned len=wcslen(temp);
 		wcscpy(m_tokenValue.pszString,temp);
 		if (len+2<=MAX_STRING)
 		{
-			m_tokenValue.pszString[len]=(WCHAR)num;
+			m_tokenValue.pszString[len]=(wchar_t)num;
 			len++;
 			m_tokenValue.pszString[len]='\0';
 		}
 		GetNextChar();
 	}
-#else
-#error "TODO: Implement this function under other OS than Windows"
-#endif 
 	return found;
 }
 
@@ -1207,7 +1211,7 @@
 */
 void PkgParser::GetAlphaNumericToken()
 {
-	WORD wCount = 0;
+	unsigned short wCount = 0;
 	while(m_pkgChar && (isalnum(m_pkgChar) || ((m_pkgChar) == '_')))
 	{
 		if(wCount < (MAX_STRING - 1))
@@ -1232,12 +1236,13 @@
 	{
 		// we may have a number but we must look ahead one char to be certain
 		
-		WCHAR oldChar = m_pkgChar;
-		DWORD fileOffset=::SetFilePointer(iPkgHandle, 0L, NULL, FILE_CURRENT);
+		wchar_t oldChar = m_pkgChar;
+		std::fpos_t foff;
+		std::fgetpos(iPkgHandle,&foff);
 		GetNextChar();
 		lexemeIsNumber = iswdigit(m_pkgChar) != FALSE;
 		m_pkgChar = oldChar;
-		::SetFilePointer(iPkgHandle,fileOffset,NULL,FILE_BEGIN);
+		std::fsetpos(iPkgHandle,&foff);
 	}
 	
 	return lexemeIsNumber;
@@ -1251,23 +1256,30 @@
 */
 void PkgParser::GetNumericToken()
 {
-	WCHAR temp[MAX_STRING];
-	LPWSTR end;
+	wchar_t temp[MAX_STRING];
+	wchar_t * end;
 	bool hexString = false;
-	DWORD dwBytesRead;
-	DWORD fileOffset=::SetFilePointer(iPkgHandle, 0L, NULL, FILE_CURRENT);
+	std::fpos_t foff;
+	std::fgetpos(iPkgHandle,&foff);
 	
 	temp[0]=m_pkgChar;
-	if (!::ReadFile(iPkgHandle, &temp[1], (MAX_STRING-2)*sizeof(WCHAR), &dwBytesRead, NULL) ||
-		dwBytesRead==0)
+	unsigned wchRead = fread(&temp[1],sizeof(wchar_t),MAX_STRING - 2,iPkgHandle);
+	if (!wchRead)
+	{ 
 		ParserError("Read failed");
-	temp[1+dwBytesRead/sizeof(WCHAR)]='\0';
-	hexString = (!CompareNString(temp, L"0x", 2) || !CompareNString(&temp[1], L"0x", 2));
+	}
+	temp[1+wchRead] = 0;
+	hexString = (!CompareNString(temp,L"0x", 2) ||
+		!CompareNString(&temp[1],L"0x", 2));
 	
 	m_tokenValue.dwNumber = wcstoul(temp, &end, (hexString) ? 16 : 10);
 	
-	if (end==temp) ParserError("Read failed"); 
-	::SetFilePointer(iPkgHandle, fileOffset+(end-temp-1)*sizeof(WCHAR), NULL, FILE_BEGIN);
+	if (end==temp)
+	{
+		ParserError("Read failed");
+	}
+	std::fsetpos(iPkgHandle,&foff);
+	std::fseek(iPkgHandle,(end-temp-1) * sizeof(wchar_t),SEEK_CUR);		
 	GetNextChar();
 }
 
@@ -1338,13 +1350,13 @@
 
 @param msg - error message to be thrown
 */
-void PkgParser::ParserError(char* msg)
+void PkgParser::ParserError(char const* msg)
 {
 	std::ostringstream str;
 
 	str << (char*)iPkgFile.data() << "(" << m_nLineNo << "): " << msg;
 
-	throw SisUtilsException("PakageFile-Parser Error", (char*)(str.str()).data());
+	throw SisUtilsException("PackageFile-Parser Error",str.str().c_str());
 }
 
 /**
@@ -1357,22 +1369,13 @@
 */
 String wstring2string (const std::wstring& aWide)
 {
-	int max = ::WideCharToMultiByte(CP_OEMCP,0,aWide.c_str(),aWide.length(),0,0,0,0);
-	String reply;
-	if (max > 0 )
-	{
-		char* buffer = new char [max];
-		try
+	std::vector<char> buffer((aWide.length() * sizeof(wchar_t)) + 1, '\0');
+	size_t nchars = wcstombs(&buffer[0],aWide.c_str(),buffer.size());
+	if (nchars == (size_t)-1)
 		{
-			::WideCharToMultiByte(CP_OEMCP,0,aWide.c_str(),aWide.length(),buffer,max,0,0);
-			reply = String (buffer, max);
-		}
-		catch (...)
-		{
-			throw SisUtilsException("ParserError", "wstring to string conversion failed");
-		}
-		delete [] buffer;
+		throw SisUtilsException("ParserError","wstring to string conversion failed");
 	}
+	String reply(&buffer[0]);
 	return reply;
 }
 
@@ -1386,22 +1389,13 @@
 */
 std::wstring string2wstring (const String& aNarrow)
 {
-	int max = ::MultiByteToWideChar(CP_OEMCP,0,aNarrow.c_str(),aNarrow.length(),0,0);
-	std::wstring reply;
-	if (max > 0 )
+	std::vector<char> buffer(mblen(aNarrow.c_str(),aNarrow.length()) + 2, '\0');
+	size_t nchars = mbstowcs((wchar_t *)&buffer[0],aNarrow.c_str(),buffer.size());
+	if (nchars == (size_t)-1)
 	{
-		wchar_t* buffer = new wchar_t [max];
-		try
-		{
-			::MultiByteToWideChar(CP_OEMCP,0,aNarrow.c_str(),aNarrow.length(),buffer,max);
-			reply = std::wstring (buffer, max);
-		}
-		catch (...)
-		{
-			throw SisUtilsException("ParserError", "string to wstring conversion failed");
-		}
-		delete [] buffer;
+		throw SisUtilsException("ParserError","string to wstring conversion failed");
 	}
+	std::wstring reply((wchar_t *)&buffer[0]);
 	return reply;
 }
 
@@ -1414,9 +1408,13 @@
 @param string - first string
 @param option - second string
 */
-int CompareTwoString(wchar_t* string ,wchar_t* option)
+int CompareTwoString(wchar_t const * string ,wchar_t const * option)
 {
+#if defined(WIN32)
 	return wcsicmp(string,option);
+#elif defined(__LINUX__)
+	return wcscasecmp(string,option);
+#endif
 }
 
 /**
@@ -1429,7 +1427,7 @@
 @param option - second string
 @param len - no of wide characters to be compared
 */
-int CompareNString(wchar_t* string ,wchar_t* option, int len)
+int CompareNString(wchar_t const * string ,wchar_t const * option, int len)
 {
-	return wcsnicmp(string,option,len);
+	return wmemcmp(string,option,len);
 }
